Subject: Re: bug#9262: test.c runs afoul of GCC 4.6.1 bug if --enable-gcc-warnings

From: Jim Meyering <[email-masked]>
Date: Mon, 08 Aug 2011 23:10:47 +0200

Paul Eggert wrote:
> I'm running into a problem with GCC 4.6.1 x86-64 when
> compiling coreutils (latest git version), configured
> with --enable-gcc-warnings.  A bogus warning is generated,
> causing "make" to fail.  The warning is "function might be
> candidate for attribute 'pure' if it is known to return
> normally [-Wsuggest-attribute=pure]", and it points to the
> "advance" function in test.c.  The warning is also generated
> for lbracket.c, which includes test.c.
>
> This is due to a GCC bug that has just been confirmed; see
> <http://gcc.gnu.org/bugzilla/show_bug.cgi?id=50021>.
>
> For now I'm leaving this alone, but I thought I'd give
> others a heads-up.  The coreutils code is pretty
> crufty but on the other hand I dislike modifying code just
> to work around bugs in static checkers.

Thanks for the heads up.
This came up in July:

    http://thread.gmane.org/gmane.comp.gnu.coreutils.general/1399

This is why I now build with gcc-4.7.x.
With it, I no longer get that invalid warning.

Ideally, configure would check for the buggy compiler
and disable the offending option when found.

If you're not going to work on that, what do you
think about sending a message to [email-masked]
with this in the body?

tags 9262 + notabug
close 9262

Since this isn't a bug in coreutils, and I'm trying to close
issues we're not likely to work on.